import java.util.*;
import java.net.*;
import java.time.*;
import java.util.concurrent.*;
import jdk.incubator.concurrent.*;

public class Sample {
  public static String getNameOfAirport(String iata) {
    /*
    try {
      var url = "https://soa.smext.faa.gov/asws/api/airport/status/" + iata;

      try(var scanner = new Scanner(new URI(url).toURL().openStream())) {
        var response = scanner.nextLine();

        if(!response.contains("Name")) {
    	  throw new RuntimeException("Invalid airport code " + iata);
        }

        return response.split("\"")[3];
      }
       */

       var mockData = Map.of(
         "AUS", "Austin", "IAH", "Houston", "DFW", "Dallas", "SAT", "San Antonio");

        var name = mockData.get(iata);

        System.out.println(iata + " " + Thread.currentThread());

	try { Thread.sleep(1000); } catch(Exception ex) {}

	if(!iata.equals("AUS")) {
	  try { Thread.sleep(1000); } catch(Exception ex) {}
	}

	if(name == null) {
	  throw new RuntimeException("Invalid airport code " + iata);
	}

	return name;
    //} catch(Exception ex) {
    //  throw new RuntimeException(ex);
    //}
  }


  public static void main(String[] args) throws Exception {
    List<String> iataCodes = List.of("AUS", "IAH", "DFW", "SAT");
 
    try(var structuredTaskScope = new StructuredTaskScope.ShutdownOnSuccess()) {
      for(var iataCode: iataCodes) {
        structuredTaskScope.fork(() -> getNameOfAirport(iataCode));
      }

      structuredTaskScope.joinUntil(Instant.now().plusSeconds(50)); 

      System.out.println(structuredTaskScope.result());
    }
  }
}


//Sometime we want one of many solutions and terminate all computations when
//we found one solution.

